Func Client_Main()
	Global $LibArray = ""
	Opt("GuiOnEventMode", 1)
	#Region Get IP of server from user and connect to it
	$Input = InputBox("RCTunes", "Please enter IP for the server", IniRead(".\RCTunes.ini","Main","IP",@IPAddress1))
	If @error Then Exit
	TCPStartup()
	Global $ConnectedSocket = TCPConnect($Input, 88)
	If @error Then
		MsgBox(0, "Error", "Failed to connect to server.")
		Exit
	EndIf
	Client_GetVer()
	#EndRegion

	#Region Save IP of server to ini
	IniWrite(".\RCTunes.ini","Main","IP",$Input)
	#EndRegion

	#Region Create GUI and set up hooks for events
	Global $FormMain = GUICreate("RCTunes", 389, 125)
	$ButtonPrev = GUICtrlCreateButton("9", 8, 40, 30, 30, $WS_GROUP)
	GUICtrlSetFont(-1, 14, 400, 0, "Webdings")
	$ButtonPP = GUICtrlCreateButton("4", 40, 40, 30, 30, $WS_GROUP)
	GUICtrlSetFont(-1, 14, 400, 0, "Webdings")
	$ButtonNext = GUICtrlCreateButton(":", 72, 40, 30, 30, $WS_GROUP)
	GUICtrlSetFont(-1, 14, 400, 0, "Webdings")
	GUICtrlCreateGroup("", 116, 24, 261, 69)
	Global $InputTitle = GUICtrlCreateInput("", 123, 36, 245, 21, BitOR($ES_CENTER, $ES_AUTOHSCROLL, $ES_READONLY))
	Global $InputArtist = GUICtrlCreateInput("", 123, 60, 245, 21, BitOR($ES_CENTER, $ES_AUTOHSCROLL, $ES_READONLY))
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$Label1 = GUICtrlCreateLabel("2009 Michael Michta", 116, 8, 260, 17, $SS_CENTER)
	Global $SliderVol = GUICtrlCreateSlider(8, 8, 94, 29)
	Global $ButtonLib = GUICtrlCreateButton("View Library", 280, 96, 99, 25, $WS_GROUP)

	GUICtrlSetOnEvent($ButtonPrev, "Client_Prev")
	GUICtrlSetOnEvent($ButtonPP, "Client_PP")
	GUICtrlSetOnEvent($ButtonNext, "Client_Next")
	GUICtrlSetOnEvent($SliderVol, "Client_Vol")
	GUICtrlSetOnEvent($ButtonLib, "Client_ViewLib")
	GUISetOnEvent($GUI_EVENT_CLOSE, "Client_Quit")
	GUISetState(@SW_SHOW)
	#EndRegion Create GUI and set up hooks for events


	#Region Main loop
	While 1
		Sleep(100)
		$Recv = TCPRecv($ConnectedSocket, 1024)
		If @error Then ;Server has gone offline
			MsgBox(0, "Error", "Lost connection to server.")
			Exit
		EndIf
		#Region Handle received data
		If $Recv <> "" Then
			If StringInStr($Recv, "<Data>") Then
				$Between = _StringBetween($Recv, "<Data>", "</Data>")
				$Split = StringSplit($Between[0], @LF)
				GUICtrlSetData($InputArtist, $Split[1])
				GUICtrlSetData($InputTitle, $Split[2])
				GUICtrlSetData($SliderVol, $Split[3])
			EndIf
		EndIf
		#EndRegion
	WEnd
	#EndRegion
EndFunc   ;==>Client_Main


Func Client_GetVer()
	Global $Connected = 0
	TCPSend($ConnectedSocket, "<Ver>")
	$Timer = TimerInit()
	Do
		$Recv = TCPRecv($ConnectedSocket, 1024)
		If $Recv <> "" Then ExitLoop
		Sleep(100)
	Until TimerDiff($Timer) >= 3000
	If StringInStr($Recv, "<Ver>") Then
		$Between = _StringBetween($Recv, "<Ver>", "</Ver>")
		If $Between[0] <> $Const_Ver Then
			MsgBox(0, "RCTunes:Error", "Client and server are different versions.")
			Exit
		Else ;If client is the same version as server
			Return
		EndIf
	EndIf
	MsgBox(0, "RCTunes:Error", "Failed to connect to server.")
	Exit
EndFunc   ;==>Client_GetVer

#Region Handle client events from GUI
Func Client_Prev()
	TCPSend($ConnectedSocket, "<PrevTrack>")
EndFunc   ;==>Client_Prev

Func Client_PP()
	TCPSend($ConnectedSocket, "<PlayPause>")
EndFunc   ;==>Client_PP

Func Client_Next()
	TCPSend($ConnectedSocket, "<NextTrack>")
EndFunc   ;==>Client_Next

Func Client_Vol()
	TCPSend($ConnectedSocket, "<Vol>" & GUICtrlRead($SliderVol) & "</Vol>")
EndFunc   ;==>Client_Vol

Func Client_ViewLib()
	GUICtrlSetOnEvent($ButtonLib, "")
	If Not IsArray($LibArray) Then
		#Region Send LibData request to server and get the data
		TCPSend($ConnectedSocket, "<GetLib>")
		$LibData = ""
		While 1
			$Recv = TCPRecv($ConnectedSocket, 1024)
			If @error Then ;Server has gone offline
				MsgBox(0, "Error", "Lost connection to server.")
				Exit
			EndIf
			If $Recv <> "" Then $LibData &= $Recv
			If StringInStr($Recv, "<End>") Then ExitLoop
		WEnd
		#EndRegion Send LibData request to server and get the data

		#Region Convert $LibData to an Array
		$HexArray = StringSplit(StringTrimRight($LibData, 5), @LF)
		Dim $TrackArray[$HexArray[0] + 1][6]
		$TrackArray[0][0] = $HexArray[0]
		For $X = 1 To $HexArray[0]
			$String = _HexToString($HexArray[$X])
			$Split = StringSplit($String, @LF)
			If $Split[0] <> 5 Then ContinueLoop
			For $Y = 1 To 5
				$TrackArray[$X][$Y - 1] = $Split[$Y]
			Next
		Next
		Global $LibArray = $TrackArray
		#EndRegion Convert $LibData to an Array
	EndIf
	#Region Create Library Browser GUI and set up hooks to events
	Global $FormLib = GUICreate("RCTunes:Library Browser", 698, 414, Default, Default, Default, Default, $FormMain)
	Global $ListView1 = GUICtrlCreateListView("Artist|Title|Album|Genre", 8, 8, 682, 358)
	GUICtrlSetOnEvent($ListView1, "Client_LV")
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 0, 150)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 1, 225)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 2, 200)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 3, 100)
	Global $InputSearch = GUICtrlCreateInput("", 512, 376, 121, 21)
	$ButtonSearch = GUICtrlCreateButton("", 640, 368, 51, 41, BitOR($BS_ICON,$WS_GROUP,$BS_DEFPUSHBUTTON))
	GUICtrlSetImage(-1, @AutoItExe, -5)
	GUICtrlSetOnEvent($ButtonSearch, "Client_Search")
	GUISetOnEvent($GUI_EVENT_CLOSE, "Client_CloseLib")
	#EndRegion Create Library Browser GUI and set up hooks to events

	#Region Populate listview
	For $X = 1 To $LibArray[0][0]
		$LibArray[$X][5] = GUICtrlCreateListViewItem($LibArray[$X][0] & "|" & $LibArray[$X][1] & "|" & $LibArray[$X][2] & "|" & $LibArray[$X][3], $ListView1)
		GUICtrlSetOnEvent(-1, "Client_Play")
	Next
	#EndRegion Populate listview

	GUISetState(@SW_SHOW)
	GUISetState(@SW_DISABLE, $FormMain)

EndFunc   ;==>Client_ViewLib

Func Client_Quit()
	Exit
EndFunc   ;==>Client_Quit

Func Client_CloseLib()
	GUISetState(@SW_ENABLE, $FormMain)
	GUICtrlSetOnEvent($ButtonLib, "Client_ViewLib")
	GUIDelete($FormLib)
EndFunc   ;==>Client_CloseLib

Func Client_Play()
	$Item = @GUI_CtrlId
	If $Item = 0 Then Return
	$Item = $LibArray[_ArraySearchAnyDim($LibArray, $Item, 1, 0, 0, "[x][5]")][4]
	TCPSend($ConnectedSocket, "<PlayItem>" & $Item & "</PlayItem>")
EndFunc   ;==>Client_Play



Func Client_Search()
	$Search = GUICtrlRead($InputSearch)
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($ListView1))
	For $X = 1 To $LibArray[0][0]
		If ($Search = "") Or (StringInStr($LibArray[$X][0] & $LibArray[$X][1] & $LibArray[$X][2] & $LibArray[$X][3], $Search)) Then
			$LibArray[$X][5] = GUICtrlCreateListViewItem($LibArray[$X][0] & "|" & $LibArray[$X][1] & "|" & $LibArray[$X][2] & "|" & $LibArray[$X][3], $ListView1)
			GUICtrlSetOnEvent(-1, "Client_Play")
		Else
			$LibArray[$X][5] = ""
		EndIf
	Next
EndFunc   ;==>Client_Search

Func Client_LV()
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($ListView1))
	_ArraySort($LibArray,0,1,0,GuiCtrlGetState($ListView1))
	For $X = 1 To $LibArray[0][0]
		$LibArray[$X][5] = GUICtrlCreateListViewItem($LibArray[$X][0] & "|" & $LibArray[$X][1] & "|" & $LibArray[$X][2] & "|" & $LibArray[$X][3], $ListView1)
		GUICtrlSetOnEvent(-1, "Client_Play")
	Next
EndFunc   ;==>_Client_LV

