Func Server_Main()
	Opt("GuiOnEventMode", 1)


	#Region Hook iTunes COM object
	Global $oiTunes = ObjCreate("iTunes.Application")
	If @error Then
		MsgBox(0, "RCTunes:Error", "Failed to hook iTunes COM object.")
		Exit
	EndIf
	#EndRegion

	#Region Handle COM Errors
	Global $oError=ObjEvent("AutoIt.Error","Server_COMError")
	#EndRegion



	#Region Create GUI and set up hooks for events
	$Form1 = GUICreate("RCTunes", 211, 67)
	$Label=GUICtrlCreateLabel("Parsing Library...", 38, 4, 135, 17,$SS_CENTER)

	$ButtonExit = GUICtrlCreateButton("Exit", 68, 36, 75, 25, $WS_GROUP)
	GUICtrlSetOnEvent($ButtonExit, "Server_Quit")
	GUISetOnEvent($GUI_EVENT_CLOSE, "Server_Quit")
	GUISetState(@SW_SHOW)
	#EndRegion

	#Region Build array of tracks from iTunes library
	$MusicPlaylist=$oiTunes.LibrarySource.Playlists.ItemByName("Music")
	Global $LibArray[$MusicPlaylist.Tracks.Count + 1][5]
	$LibArray[0][0] = $MusicPlaylist.Tracks.Count
	For $X = 1 To $MusicPlaylist.Tracks.Count
		$Track = $MusicPlaylist.Tracks($X)
		If $Track.Artist <> "0" Then $LibArray[$X][0] = $Track.Artist
		If $Track.Name <> "0" Then $LibArray[$X][1] = $Track.Name
		If $Track.Album <> "0" Then $LibArray[$X][2] = $Track.Album
		If $Track.Genre <> "0" Then $LibArray[$X][3] = $Track.Genre
		$LibArray[$X][4] = $Track
	Next
	#EndRegion





	#Region Create TCP server and listen for connections
	TCPStartup()
	Global $MainSocket = TCPListen(@IPAddress1, 88, 1)
	If $MainSocket = -1 Then Exit
	GuiCtrlSetData($Label,"Listening on:"&@IPAddress1)
	While 1
		Global $ConnectedSocket = TCPAccept($MainSocket)
		If $ConnectedSocket >= 0 Then
			Global $Data = ""
			AdlibRegister("Server_Broadcast", 500)
			Server_Connected($ConnectedSocket)
			AdlibUnRegister("Server_Broadcast")
		EndIf
	WEnd

	#EndRegion

EndFunc   ;==>Server_Main

#Region Function For handling connected client
Func Server_Connected($Socket)
	While 1
		$Recv = TCPRecv($Socket, 1024 * 100)
		If @error Then Return ;Client has disconnected
		#Region Handle received data
		If $Recv <> "" Then
			If StringInStr($Recv, "<Ver>") Then
				TCPSend($Socket, "<Ver>" & $Const_Ver & "</Ver>")
			EndIf
			If StringInStr($Recv, "<GetData>") Then
				TCPSend($Socket, "<Data>" & $oiTunes.currenttrack.name & @LF & $oiTunes.currenttrack.Artist & @LF & $oiTunes.SoundVolume & "</Data>")
			EndIf
			If StringInStr($Recv, "<PlayPause>") Then
				$oiTunes.PlayPause
			EndIf
			If StringInStr($Recv, "<NextTrack>") Then
				$oiTunes.NextTrack
			EndIf
			If StringInStr($Recv, "<PrevTrack>") Then
				$oiTunes.PreviousTrack
			EndIf
			If StringInStr($Recv, "<Vol>") Then
				$Between = _StringBetween($Recv, "<Vol>", "</Vol>")
				$oiTunes.SoundVolume = $Between[0]
			EndIf
			If StringInStr($Recv, "<GetLib>") Then
				$TCPData = ""
				For $X = 1 To $LibArray[0][0]
					$TCPData &= _StringToHex($LibArray[$X][0] & @LF & $LibArray[$X][1] & @LF & $LibArray[$X][2] & @LF & $LibArray[$X][3] & @LF & $X ) & @LF
				Next
				TCPSend($Socket, StringTrimRight($TCPData,1) & "<End>");StringTrimRight removes trailing @LF
			EndIf
			If StringInStr($Recv, "<PlayItem>") Then
				$Between = _StringBetween($Recv, "<PlayItem>", "</PlayItem>")
				$LibArray[$Between[0]][4].Play
			EndIf

		EndIf
		#EndRegion
	WEnd
EndFunc   ;==>Server_Connected
#EndRegion


#Region Function for when server is closed
Func Server_Quit()
	Exit
EndFunc   ;==>Server_Quit
#EndRegion

#Region AdLib function to send new data to client if iTunes has changed
Func Server_Broadcast()
	If Not IsObj($oiTunes.currenttrack) Then
		Global $Data=""
		TCPSend($ConnectedSocket, "<Data>" & @LF & @LF & $oiTunes.SoundVolume & "</Data>")
		Return
	EndIf
	$NewData = $oiTunes.currenttrack.name & @LF & $oiTunes.currenttrack.Artist & @LF & $oiTunes.SoundVolume
	If $NewData <> $Data Then
		Global $Data = $NewData
		TCPSend($ConnectedSocket, "<Data>" & $Data & "</Data>")
	EndIf
EndFunc   ;==>_Server_Broadcast
#EndRegion

#Region Dummy function to catch com errors
Func Server_COMError()
	Return
Endfunc
#EndRegion



